<?php

/**
 * WHMCS Paysepro Module
 * Version: 1.1
 * Date : 	2021-04-26
 *
 */

// Require libraries needed for gateway module functions.
require_once __DIR__ . '/../../../init.php';
require_once __DIR__ . '/../../../includes/gatewayfunctions.php';
require_once __DIR__ . '/../../../includes/invoicefunctions.php';

// Detect module name from filename.
$gatewayModuleName = basename(__FILE__, '.php');

// Fetch gateway configuration parameters.
$gatewayParams = getGatewayVariables($gatewayModuleName);

// Die if module is not active.
if (!$gatewayParams['type']) {
    die("Module Not Activated");
}

// Check if sufficent parameters pass at callback
if(!isset($_GET['result']) or !isset($_GET['ucode'])) {
	//header("Location:$gatewayParams[systemurl]");
	die("Callback called without result or ucode.");
}

// Retrieve data returned in payment gateway callback
$status = $_GET["result"] == "ok" ? 1 : 0;
$invoiceId = isset($_GET["ucode"]) ? $_GET["ucode"] : "";
$amount = isset($_GET["price"]) ? floatval($_GET["price"]) : "";
$transid = $invoiceId;

// Checks invoice ID is a valid invoice number or ends processing
$invoiceId = checkCbInvoiceID($invoiceId, $gatewayParams['name']);
		
// Checks transaction number isn't already in the database and ends processing if it does
checkCbTransID($invoiceId);

if ($status == "1"&&$_SERVER["REMOTE_ADDR"]=="51.195.200.178") {
			
	$amount = '';	// left blank, this will auto-fill as the full balance
	$fee = 0;
			
	// Successful 
	// Apply Payment to Invoice: invoiceid, transactionid, amount paid, fees, modulename
	addInvoicePayment($invoiceId, $transid, $amount, $fee, $gatewayParams["name"]);
			
	// Save to Gateway Log: name, data array, status
	logTransaction($gatewayParams["name"], $_GET, $status);
} 
else {

	# Unsuccessful
	# Save to Gateway Log: name, data array, status
	logTransaction($gatewayParams["name"], $_GET, $status);
}

// Redirect to invoice
header( "Location: ".$gatewayParams['systemurl']."viewinvoice.php?action=edit&id=" . $invoiceId);
